ompi/attribute/attribute.c File Reference.TH "ompi/attribute/attribute.c" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/attribute/attribute.c \- Back-end MPI attribute engine. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'attribute/attribute.h'\fP
.br
\fC#include 'opal/threads/mutex.h'\fP
.br
\fC#include 'ompi/include/constants.h'\fP
.br
\fC#include 'datatype/datatype.h'\fP
.br
\fC#include 'communicator/communicator.h'\fP
.br
\fC#include 'win/win.h'\fP
.br
\fC#include 'mpi/f77/fint_2_int.h'\fP
.br
\fC#include 'class/ompi_bitmap.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBATTR_TABLE_SIZE\fP   10"
.br
.ti -1c
.RI "#define \fBMPI_DATATYPE_NULL_COPY_FN\fP   MPI_TYPE_NULL_COPY_FN"
.br
.ti -1c
.RI "#define \fBattr_communicator_f\fP   c_f_to_c_index"
.br
.ti -1c
.RI "#define \fBattr_datatype_f\fP   d_f_to_c_index"
.br
.ti -1c
.RI "#define \fBattr_win_f\fP   w_f_to_c_index"
.br
.ti -1c
.RI "#define \fBCREATE_KEY\fP(key)   ompi_bitmap_find_and_set_first_unset_bit(key_bitmap, (key))"
.br
.ti -1c
.RI "#define \fBFREE_KEY\fP(key)   ompi_bitmap_clear_bit(key_bitmap, (key))"
.br
.ti -1c
.RI "#define \fBDELETE_ATTR_CALLBACKS\fP(type, attribute, keyval_obj)"
.br
.ti -1c
.RI "#define \fBCOPY_ATTR_CALLBACKS\fP(type, old_object, keyval_obj, in_attr, out_attr)"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef enum ompi_attribute_translate_t \fBompi_attribute_translate_t\fP"
.br
.ti -1c
.RI "typedef attribute_value_t \fBattribute_value_t\fP"
.br
.in -1c
.SS "Enumerations"

.in +1c
.ti -1c
.RI "enum \fBompi_attribute_translate_t\fP { \fBOMPI_ATTRIBUTE_C\fP, \fBOMPI_ATTRIBUTE_FORTRAN_MPI1\fP, \fBOMPI_ATTRIBUTE_FORTRAN_MPI2\fP }"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "static void \fBattribute_value_construct\fP (attribute_value_t *item)"
.br
.ti -1c
.RI "static void \fBompi_attrkey_item_construct\fP (ompi_attrkey_item_t *item)"
.br
.ti -1c
.RI "static void \fBompi_attrkey_item_destruct\fP (ompi_attrkey_item_t *item)"
.br
.ti -1c
.RI "static int \fBset_value\fP (\fBompi_attribute_type_t\fP type, void *object, opal_hash_table_t **keyhash, int key, attribute_value_t *new_attr, bool predefined, bool need_lock)"
.br
.ti -1c
.RI "static int \fBget_value\fP (opal_hash_table_t *keyhash, int key, attribute_value_t **attribute, int *flag)"
.br
.ti -1c
.RI "static void * \fBtranslate_to_c\fP (attribute_value_t *val)"
.br
.ti -1c
.RI "static MPI_Fint \fBtranslate_to_fortran_mpi1\fP (attribute_value_t *val)"
.br
.ti -1c
.RI "static MPI_Aint \fBtranslate_to_fortran_mpi2\fP (attribute_value_t *val)"
.br
.ti -1c
.RI "static \fBOBJ_CLASS_INSTANCE\fP (attribute_value_t, \fBopal_object_t\fP, attribute_value_construct, NULL)"
.br
.ti -1c
.RI "static \fBOBJ_CLASS_INSTANCE\fP (ompi_attrkey_item_t, \fBopal_object_t\fP, ompi_attrkey_item_construct, ompi_attrkey_item_destruct)"
.br
.ti -1c
.RI "int \fBompi_attr_init\fP (void)"
.br
.RI "\fIInitialize the main attribute hash that stores the key and meta data. \fP"
.ti -1c
.RI "int \fBompi_attr_finalize\fP (void)"
.br
.RI "\fIDestroy the main attribute hash that stores the key and meta data. \fP"
.ti -1c
.RI "int \fBompi_attr_create_keyval\fP (\fBompi_attribute_type_t\fP type, ompi_attribute_fn_ptr_union_t copy_attr_fn, ompi_attribute_fn_ptr_union_t delete_attr_fn, int *key, void *extra_state, int flags)"
.br
.RI "\fICreate a new key for use by attribute of Comm/Win/Datatype. \fP"
.ti -1c
.RI "int \fBompi_attr_free_keyval\fP (\fBompi_attribute_type_t\fP type, int *key, bool predefined)"
.br
.RI "\fIFree an attribute keyval. \fP"
.ti -1c
.RI "int \fBompi_attr_delete\fP (\fBompi_attribute_type_t\fP type, void *object, opal_hash_table_t *keyhash, int key, bool predefined, bool need_lock)"
.br
.RI "\fIDelete an attribute on the comm/win/datatype. \fP"
.ti -1c
.RI "int \fBompi_attr_set_c\fP (\fBompi_attribute_type_t\fP type, void *object, opal_hash_table_t **keyhash, int key, void *attribute, bool predefined, bool need_lock)"
.br
.RI "\fISet an attribute on the comm/win/datatype in a form valid for C. \fP"
.ti -1c
.RI "int \fBompi_attr_set_fortran_mpi1\fP (\fBompi_attribute_type_t\fP type, void *object, opal_hash_table_t **keyhash, int key, MPI_Fint attribute, bool predefined, bool need_lock)"
.br
.RI "\fISet an attribute on the comm/win/datatype in a form valid for Fortran MPI-1. \fP"
.ti -1c
.RI "int \fBompi_attr_set_fortran_mpi2\fP (\fBompi_attribute_type_t\fP type, void *object, opal_hash_table_t **keyhash, int key, MPI_Aint attribute, bool predefined, bool need_lock)"
.br
.RI "\fISet an attribute on the comm/win/datatype in a form valid for Fortran MPI-2. \fP"
.ti -1c
.RI "int \fBompi_attr_get_c\fP (opal_hash_table_t *keyhash, int key, void **attribute, int *flag)"
.br
.RI "\fIGet an attribute on the comm/win/datatype in a form valid for C. \fP"
.ti -1c
.RI "int \fBompi_attr_get_fortran_mpi1\fP (opal_hash_table_t *keyhash, int key, MPI_Fint *attribute, int *flag)"
.br
.RI "\fIGet an attribute on the comm/win/datatype in a form valid for Fortran MPI-1. \fP"
.ti -1c
.RI "int \fBompi_attr_get_fortran_mpi2\fP (opal_hash_table_t *keyhash, int key, MPI_Aint *attribute, int *flag)"
.br
.RI "\fIGet an attribute on the comm/win/datatype in a form valid for Fortran MPI-2. \fP"
.ti -1c
.RI "int \fBompi_attr_copy_all\fP (\fBompi_attribute_type_t\fP type, void *old_object, void *new_object, opal_hash_table_t *oldkeyhash, opal_hash_table_t *newkeyhash)"
.br
.RI "\fIThis to be used from functions like MPI_*_DUP inorder to copy all the attributes from the old Comm/Win/Dtype object to a new object. \fP"
.ti -1c
.RI "int \fBompi_attr_delete_all\fP (\fBompi_attribute_type_t\fP type, void *object, opal_hash_table_t *keyhash)"
.br
.RI "\fIThis to be used to delete all the attributes from the Comm/Win/Dtype object in one shot. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "static opal_hash_table_t * \fBkeyval_hash\fP"
.br
.ti -1c
.RI "static ompi_bitmap_t * \fBkey_bitmap\fP"
.br
.ti -1c
.RI "static unsigned int \fBint_pos\fP = 12345"
.br
.in -1c
.SH "Detailed Description"
.PP 
Back-end MPI attribute engine. 

This is complicated enough that it deserves a lengthy discussion of what is happening. This is extremely complicated stuff, paired with the fact that it is not described well in the MPI standard. There are several places in the standard that should be read about attributes:
.PP
MPI-1: Section 5.7 (pp 167-173) MPI-1: Section 7.1 (pp 191-192) predefined attributes in MPI-1 MPI-2: Section 4.12.7 (pp 57-59) interlanguage attribute clarifications MPI-2: Section 6.2.2 (pp 112) window predefined attributes MPI-2: Section 8.8 (pp 198-208) new attribute caching functions
.PP
After reading all of this, note the following:
.PP
.IP "\(bu" 2
C MPI-1 and MPI-2 attribute functions and functionality are identical except for their function names.
.IP "\(bu" 2
Fortran MPI-1 and MPI-2 attribute functions and functionality are different (namely: the parameters are different sizes, both in the functions and the user callbacks, and the assignments to the different sized types occur differently [e.g., truncation and sign extension])
.IP "\(bu" 2
C functions store values by reference (i.e., writing an attribute means writing a pointer to an instance of something; changing the value of that instance will make it visible to anyone who reads that attribute value).
.IP "\(bu" 2
Fortran functions store values by value (i.e., writing an attribute value means that anyone who reads that attribute value will not be able to affect the value read by anyone else).
.IP "\(bu" 2
The predefined attribute MPI_WIN_BASE seems to flaunt the rules designated by the rest of the standard; it is handled specifically in the MPI_WIN_GET_ATTR binding functions (see the comments in there for an explanation).
.IP "\(bu" 2
MPI-2 4.12.7:Example 4.13 (p58) is wrong. The C->Fortran example should have the Fortran 'val' variable equal to &I.
.PP
.PP
By the first two of these, there are 9 possible use cases -- 3 possibilities for writing an attribute value, each of which has 3 possibilities for reading that value back. The following lists each of the 9 cases, and what happens in each.
.PP
Cases where C writes an attribute value: ----------------------------------------
.PP
In all of these cases, a pointer was written by C (e.g., a pointer to an int -- but it could have been a pointer to anything, such as a struct). These scenarios each have 2 examples:
.PP
Example A: int foo = 3; MPI_Attr_put(..., &foo); Example B: struct foo bar; MPI_Attr_put(..., &bar);
.PP
1. C reads the attribute value. Clearly, this is a 'unity' case, and no translation occurs. A pointer is written, and that same pointer is returned.
.PP
Example A: int *ret; MPI_Attr_get(..., &ret); --> *ret will equal 3 Example B: struct foo *ret; MPI_Attr_get(..., &ret); --> *ret will point to the instance bar that was written
.PP
2. Fortran MPI-1 reads the attribute value. The C pointer is cast to a fortran INTEGER (i.e., MPI_Fint) -- potentially being truncated if sizeof(void*) > sizeof(INTEGER).
.PP
Example A: INTEGER ret CALL MPI_ATTR_GET(..., ret, ierr) --> ret will equal &foo, possibly truncaed Example B: INTEGER ret CALL MPI_ATTR_GET(..., ret, ierr) --> ret will equal &bar, possibly truncaed
.PP
3. Fortran MPI-2 reads the attribute value. The C pointer is cast to a fortran INTEGER(KIND=MPI_ADDRESS_KIND) (i.e., a (MPI_Aint)).
.PP
Example A: INTEGER(KIND=MPI_ADDRESS_KIND) ret CALL MPI_COMM_GET_ATTR(..., ret, ierr) --> ret will equal &foo Example B: INTEGER(KIND=MPI_ADDRESS_KIND) ret CALL MPI_COMM_GET_ATTR(..., ret, ierr) --> ret will equal &bar
.PP
Cases where Fortran MPI-1 writes an attribute value: ----------------------------------------------------
.PP
In all of these cases, an INTEGER is written by Fortran.
.PP
Example: INTEGER FOO = 7 CALL MPI_ATTR_PUT(..., foo, ierr)
.PP
4. C reads the attribute value. The value returned is a pointer that points to an INTEGER (i.e., an MPI_Fint) that has a value of 7. --> NOTE: The external MPI interface does not distinguish between this case and case 7. It is the programer's responsibility to code accordingly.
.PP
Example: MPI_Fint *ret; MPI_Attr_get(..., &ret); -> *ret will equal 7.
.PP
5. Fortran MPI-1 reads the attribute value. This is the unity case; the same value is returned.
.PP
Example: INTEGER ret CALL MPI_ATTR_GET(..., ret, ierr) --> ret will equal 7
.PP
6. Fortran MPI-2 reads the attribute value. The same value is returned, but potentially sign-extended if sizeof(INTEGER) < sizeof(INTEGER(KIND=MPI_ADDRESS_KIND)).
.PP
Example: INTEGER(KIND=MPI_ADDRESS_KIND) ret CALL MPI_COMM_GET_ATTR(..., ret, ierr) --> ret will equal 7
.PP
Cases where Fortran MPI-2 writes an attribute value: ----------------------------------------------------
.PP
In all of these cases, an INTEGER(KIND=MPI_ADDRESS_KIND) is written by Fortran.
.PP
Example A: INTEGER(KIND=MPI_ADDRESS_KIND) FOO = 12 CALL MPI_COMM_PUT_ATTR(..., foo, ierr) Example B: // Assume a platform where sizeof(void*) = 8 and // sizeof(INTEGER) = 4. INTEGER(KIND=MPI_ADDRESS_KIND) FOO = pow(2, 40) CALL MPI_COMM_PUT_ATTR(..., foo, ierr)
.PP
7. C reads the attribute value. The value returned is a pointer that points to an INTEGER(KIND=MPI_ADDRESS_KIND) (i.e., a void*) that has a value of 12. --> NOTE: The external MPI interface does not distinguish between this case and case 4. It is the programer's responsibility to code accordingly.
.PP
Example A: MPI_Aint *ret; MPI_Attr_get(..., &ret); -> *ret will equal 12 Example B: MPI_Aint *ret; MPI_Attr_get(..., &ret); -> *ret will equal 2^40
.PP
8. Fortran MPI-1 reads the attribute value. The same value is returned, but potentially truncated if sizeof(INTEGER) < sizeof(INTEGER(KIND=MPI_ADDRESS_KIND)).
.PP
Example A: INTEGER ret CALL MPI_ATTR_GET(..., ret, ierr) --> ret will equal 12 Example B: INTEGER ret CALL MPI_ATTR_GET(..., ret, ierr) --> ret will equal 0
.PP
9. Fortran MPI-2 reads the attribute value. This is the unity case; the same value is returned.
.PP
Example A: INTEGER(KIND=MPI_ADDRESS_KIND) ret CALL MPI_COMM_GET_ATTR(..., ret, ierr) --> ret will equal 7 Example B: INTEGER(KIND=MPI_ADDRESS_KIND) ret CALL MPI_COMM_GET_ATTR(..., ret, ierr) --> ret will equal 2^40
.SH "Function Documentation"
.PP 
.SS "int ompi_attr_copy_all (\fBompi_attribute_type_t\fP type, void * old_object, void * new_object, opal_hash_table_t * oldkeyhash, opal_hash_table_t * newkeyhash)"
.PP
This to be used from functions like MPI_*_DUP inorder to copy all the attributes from the old Comm/Win/Dtype object to a new object. 
.PP
\fBParameters:\fP
.RS 4
\fItype\fP Type of attribute (COMM/WIN/DTYPE) (IN) 
.br
\fIold_object\fP The old COMM/WIN/DTYPE object (IN) 
.br
\fInew_object\fP The new COMM/WIN/DTYPE object (IN) 
.br
\fIkeyhash\fP The attribute hash table hanging on old object(IN) 
.br
\fInewkeyhash\fP The attribute hash table hanging on new object(IN) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code 
.RE
.PP

.SS "int ompi_attr_create_keyval (\fBompi_attribute_type_t\fP type, ompi_attribute_fn_ptr_union_t copy_attr_fn, ompi_attribute_fn_ptr_union_t delete_attr_fn, int * key, void * extra_state, int flags)"
.PP
Create a new key for use by attribute of Comm/Win/Datatype. 
.PP
\fBParameters:\fP
.RS 4
\fItype\fP Type of attribute (COMM/WIN/DTYPE) (IN) 
.br
\fIcopy_attr_fn\fP Union variable containing the function pointer to be used in order to copy the attribute (IN) 
.br
\fIdelete_attr_fn\fP Function pointer to be used for deleting the attribute (IN) 
.br
\fIkey\fP The newly created key is returned here (OUT) 
.br
\fIextra_state\fP Extra state to hang off/do some special things (IN) 
.br
\fIflags\fP Flags for the key -- flags contain OMPI_KEYVAL_F77, OMPI_KEYVAL_PREDEFINED NOTE: I have taken the assumption that user cannot modify/delete any predefined keys or the attributes attached. To accomplish this, all MPI* calls will have OMPI_KEYVAL_PREDEFINED set as 0. MPI implementors who will need to play with the predefined keys and attributes would call the ompi* functions here and not the MPI* functions, with OMPI_KEYVAL_PREDEFINED set to 1. END OF NOTE
.RE
.PP
NOTE: For the function pointers, you need to create a variable of the union type 'ompi_attribute_fn_ptr_union_t' and assign the proper field. to be passed into this function END OF NOTE
.PP
\fBReturns:\fP
.RS 4
OMPI return code 
.RE
.PP

.SS "int ompi_attr_delete (\fBompi_attribute_type_t\fP type, void * object, opal_hash_table_t * keyhash, int key, bool predefined, bool need_lock)"
.PP
Delete an attribute on the comm/win/datatype. 
.PP
\fBParameters:\fP
.RS 4
\fItype\fP Type of attribute (COMM/WIN/DTYPE) (IN) 
.br
\fIobject\fP The actual Comm/Win/Datatype object (IN) 
.br
\fIkeyhash\fP The attribute hash table hanging on the object(IN) 
.br
\fIkey\fP Key val for the attribute (IN) 
.br
\fIpredefined\fP Whether the key is predefined or not 0/1 (IN) 
.br
\fIneed_lock\fP Whether we need to need to lock the keyval_lock or not 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code
.RE
.PP
Note that need_lock should *always* be true when this function is invoked from an top-level MPI function. It is only false when this function is invoked internally (i.e., when we already hold the relevant locks, and we don't want to try to lock them again, recursively). 
.SS "int ompi_attr_delete_all (\fBompi_attribute_type_t\fP type, void * object, opal_hash_table_t * keyhash)"
.PP
This to be used to delete all the attributes from the Comm/Win/Dtype object in one shot. 
.PP
\fBParameters:\fP
.RS 4
\fItype\fP Type of attribute (COMM/WIN/DTYPE) (IN) 
.br
\fIobject\fP The COMM/WIN/DTYPE object (IN) 
.br
\fIkeyhash\fP The attribute hash table hanging on the object(IN) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code 
.RE
.PP

.SS "int ompi_attr_free_keyval (\fBompi_attribute_type_t\fP type, int * key, bool predefined)"
.PP
Free an attribute keyval. 
.PP
\fBParameters:\fP
.RS 4
\fItype\fP Type of attribute (COMM/WIN/DTYPE) (IN) 
.br
\fIkey\fP key, which is set to MPI_KEY_INVALID (IN/OUT) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code 
.RE
.PP

.SS "int ompi_attr_get_c (opal_hash_table_t * keyhash, int key, void ** attribute, int * flag)"
.PP
Get an attribute on the comm/win/datatype in a form valid for C. 
.PP
\fBParameters:\fP
.RS 4
\fIkeyhash\fP The attribute hash table hanging on the object(IN) 
.br
\fIkey\fP Key val for the attribute (IN) 
.br
\fIattribute\fP The actual attribute pointer (OUT) 
.br
\fIflag\fP Flag whether an attribute is associated with the key (OUT) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code
.RE
.PP
All three of these functions (\fBompi_attr_get_c()\fP, \fBompi_attr_get_fortran_mpi1()\fP, and \fBompi_attr_get_fortran_mpi2()\fP) could have been combined into one function that took some kind of (void*) and an enum to indicate which way to translate the final representation, but that just seemed to make an already complicated situation more complicated through yet another layer of indirection.
.PP
So yes, this is more code, but it's clearer and less error-prone (read: better) this way. 
.SS "int ompi_attr_get_fortran_mpi1 (opal_hash_table_t * keyhash, int key, MPI_Fint * attribute, int * flag)"
.PP
Get an attribute on the comm/win/datatype in a form valid for Fortran MPI-1. 
.PP
\fBParameters:\fP
.RS 4
\fIkeyhash\fP The attribute hash table hanging on the object(IN) 
.br
\fIkey\fP Key val for the attribute (IN) 
.br
\fIattribute\fP The actual attribute pointer (OUT) 
.br
\fIflag\fP Flag whether an attribute is associated with the key (OUT) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code
.RE
.PP
All three of these functions (\fBompi_attr_get_c()\fP, \fBompi_attr_get_fortran_mpi1()\fP, and \fBompi_attr_get_fortran_mpi2()\fP) could have been combined into one function that took some kind of (void*) and an enum to indicate which way to translate the final representation, but that just seemed to make an already complicated situation more complicated through yet another layer of indirection.
.PP
So yes, this is more code, but it's clearer and less error-prone (read: better) this way. 
.SS "int ompi_attr_get_fortran_mpi2 (opal_hash_table_t * keyhash, int key, MPI_Aint * attribute, int * flag)"
.PP
Get an attribute on the comm/win/datatype in a form valid for Fortran MPI-2. 
.PP
\fBParameters:\fP
.RS 4
\fIkeyhash\fP The attribute hash table hanging on the object(IN) 
.br
\fIkey\fP Key val for the attribute (IN) 
.br
\fIattribute\fP The actual attribute pointer (OUT) 
.br
\fIflag\fP Flag whether an attribute is associated with the key (OUT) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code
.RE
.PP
All three of these functions (\fBompi_attr_get_c()\fP, \fBompi_attr_get_fortran_mpi1()\fP, and \fBompi_attr_get_fortran_mpi2()\fP) could have been combined into one function that took some kind of (void*) and an enum to indicate which way to translate the final representation, but that just seemed to make an already complicated situation more complicated through yet another layer of indirection.
.PP
So yes, this is more code, but it's clearer and less error-prone (read: better) this way. 
.SS "int ompi_attr_init (void)"
.PP
Initialize the main attribute hash that stores the key and meta data. 
.PP
\fBReturns:\fP
.RS 4
OMPI return code 
.RE
.PP

.SS "int ompi_attr_set_c (\fBompi_attribute_type_t\fP type, void * object, opal_hash_table_t ** keyhash, int key, void * attribute, bool predefined, bool need_lock)"
.PP
Set an attribute on the comm/win/datatype in a form valid for C. 
.PP
\fBParameters:\fP
.RS 4
\fItype\fP Type of attribute (COMM/WIN/DTYPE) (IN) 
.br
\fIobject\fP The actual Comm/Win/Datatype object (IN) 
.br
\fIkeyhash\fP The attribute hash table hanging on the object(IN/OUT) 
.br
\fIkey\fP Key val for the attribute (IN) 
.br
\fIattribute\fP The actual attribute pointer (IN) 
.br
\fIpredefined\fP Whether the key is predefined or not 0/1 (IN) 
.br
\fIneed_lock\fP Whether we need to need to lock the keyval_lock or not 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code
.RE
.PP
If (*keyhash) == NULL, a new keyhash will be created and initialized.
.PP
Note that need_lock should *always* be true when this function is invoked from an top-level MPI function. It is only false when this function is invoked internally (i.e., when we already hold the relevant locks, and we don't want to try to lock them again, recursively).
.PP
All three of these functions (\fBompi_attr_set_c()\fP, \fBompi_attr_set_fortran_mpi1()\fP, and \fBompi_attr_set_fortran_mpi2()\fP) could have been combined into one function that took some kind of (void*) and an enum to indicate which way to translate the final representation, but that just seemed to make an already complicated situation more complicated through yet another layer of indirection.
.PP
So yes, this is more code, but it's clearer and less error-prone (read: better) this way. 
.SS "int ompi_attr_set_fortran_mpi1 (\fBompi_attribute_type_t\fP type, void * object, opal_hash_table_t ** keyhash, int key, MPI_Fint attribute, bool predefined, bool need_lock)"
.PP
Set an attribute on the comm/win/datatype in a form valid for Fortran MPI-1. 
.PP
\fBParameters:\fP
.RS 4
\fItype\fP Type of attribute (COMM/WIN/DTYPE) (IN) 
.br
\fIobject\fP The actual Comm/Win/Datatype object (IN) 
.br
\fIkeyhash\fP The attribute hash table hanging on the object(IN/OUT) 
.br
\fIkey\fP Key val for the attribute (IN) 
.br
\fIattribute\fP The actual attribute pointer (IN) 
.br
\fIpredefined\fP Whether the key is predefined or not 0/1 (IN) 
.br
\fIneed_lock\fP Whether we need to need to lock the keyval_lock or not 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code
.RE
.PP
If (*keyhash) == NULL, a new keyhash will be created and initialized.
.PP
Note that need_lock should *always* be true when this function is invoked from an top-level MPI function. It is only false when this function is invoked internally (i.e., when we already hold the relevant locks, and we don't want to try to lock them again, recursively).
.PP
All three of these functions (\fBompi_attr_set_c()\fP, \fBompi_attr_set_fortran_mpi1()\fP, and \fBompi_attr_set_fortran_mpi2()\fP) could have been combined into one function that took some kind of (void*) and an enum to indicate which way to translate the final representation, but that just seemed to make an already complicated situation more complicated through yet another layer of indirection.
.PP
So yes, this is more code, but it's clearer and less error-prone (read: better) this way. 
.SS "int ompi_attr_set_fortran_mpi2 (\fBompi_attribute_type_t\fP type, void * object, opal_hash_table_t ** keyhash, int key, MPI_Aint attribute, bool predefined, bool need_lock)"
.PP
Set an attribute on the comm/win/datatype in a form valid for Fortran MPI-2. 
.PP
\fBParameters:\fP
.RS 4
\fItype\fP Type of attribute (COMM/WIN/DTYPE) (IN) 
.br
\fIobject\fP The actual Comm/Win/Datatype object (IN) 
.br
\fIkeyhash\fP The attribute hash table hanging on the object(IN/OUT) 
.br
\fIkey\fP Key val for the attribute (IN) 
.br
\fIattribute\fP The actual attribute pointer (IN) 
.br
\fIpredefined\fP Whether the key is predefined or not 0/1 (IN) 
.br
\fIneed_lock\fP Whether we need to need to lock the keyval_lock or not 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code
.RE
.PP
If (*keyhash) == NULL, a new keyhash will be created and initialized.
.PP
Note that need_lock should *always* be true when this function is invoked from an top-level MPI function. It is only false when this function is invoked internally (i.e., when we already hold the relevant locks, and we don't want to try to lock them again, recursively).
.PP
All three of these functions (\fBompi_attr_set_c()\fP, \fBompi_attr_set_fortran_mpi1()\fP, and \fBompi_attr_set_fortran_mpi2()\fP) could have been combined into one function that took some kind of (void*) and an enum to indicate which way to translate the final representation, but that just seemed to make an already complicated situation more complicated through yet another layer of indirection.
.PP
So yes, this is more code, but it's clearer and less error-prone (read: better) this way. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
